#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>

void
xnomem(void *p)
{
  if (!p)
    {
      errno = ENOMEM;
      perror ("libgendep.so");
    }
}

char *
xstrdup (char *s)
{
  char *c = strdup (s);
  xnomem (c);
  return c;
}

void *
xrealloc (void *s, size_t sz)
{
  void *c = realloc (s, sz);
  xnomem (c);
  return c;
}

void *
xmalloc (size_t sz)
{
  void *c;
  c = malloc (sz);
  xnomem (c);
  return c;
}

void*
xcalloc (size_t nmemb, size_t onesz)
{
  void *c =   calloc (nmemb, onesz);
  xnomem (c);
  return c;
}
