#ifndef LP_PROBLEM_H
#define LP_PROBLEM_H
#include "minit.h"

struct LP_PROBLEM {
  int no_eq_constraints;
  int no_constraints;
  int no_vars;
  Real **A;
  Real *b;
  Real *c;
};

struct LP_PROBLEM *new_lp_problem (int var, int ineq, int eq);
void del_lp_problem (struct  LP_PROBLEM *);
void write_lp_problem (struct LP_PROBLEM const *, FILE *filename);
void write_lp_problem_to_file (struct LP_PROBLEM const *, char *filename);
void print_problem_size (struct LP_PROBLEM const *lpp);

struct LP_SOLUTION
{
  int n;
  int m;

  Real *prim;
  Real *dual;
  Real val;
};



void print_solution (struct LP_SOLUTION const *lps, Real precision);
struct LP_PROBLEM *read_problem (FILE *f, int suppress);
struct LP_SOLUTION *new_lp_solution(int n, int m);
void del_lp_solution (struct LP_SOLUTION*);
void init_solution (struct LP_SOLUTION *s);



int lp_solve(struct LP_PROBLEM *problem_p, struct LP_SOLUTION *);
char const *lp_solve_error (int i);



#endif
